明经CAD社区

 找回密码
 注册

QQ登录

只需一步,快速开始

搜索
查看: 2935|回复: 2

[原创]DOTNETARX(一个用于.net开发AutoCAD程序的类库)实例教学(续)

[复制链接]
发表于 2005-7-5 10:21:00 | 显示全部楼层 |阅读模式
本来已写好中文的,但不知怎么搞的,给弄丢了。先把英文的给发上来,等过段时间我再发中文的。 The following functions is provieded in DOTNETARX 2.1.
  • AddBlockTableRecord
In DOTNETARX,you can add the symbol table record using the AddSymbolTableRecord() function.But the BlockTableRecord is different from the other symbol table records.So,you must use the AddBlockTableRecord() function to add the BlockTableRecord.AddBlockTableRecord() function has two forms.The first one takes the Entity array as its argument (which represents the entities that have not added into the AutoCAD database).If you want to add the entities on the screen into the Block Table Record,you will have to use the second one.It takes the ObjectId of the entities as its argument. The following example show you how to use AddBlockTableRecord() to create Block Table Records.
    void Test()
{
Lines line=new Lines(new Point3d(0,0,0),new Point3d(50,50,0));
Circles circle=new Circles(new Point3d(50,50,0),25);
BlockTableRecord btr1=new BlockTableRecord();//Creates a new block table record named block1
btr1.Name="block1";
btr1.Origin=circle.Center;
Tools.AddBlockTableRecord(btr1,new Entity[]{line,circle});
//Adds the line and circle to block1,then adds block1 to the block table of AutoCAD database.

PromptSelectionResult res=Tools.Editor.GetSelection();//Selects objects on the screen.
ObjectIdCollection ids=new ObjectIdCollection(res.Value.GetObjectIds());
//Gets the ObjectIds of the Selected objects.
BlockTableRecord btr2=new BlockTableRecord();//Creates a new block table record named block2
btr2.Name="block2";
btr2.Origin=new Point3d(0,0,0);
Tools.AddBlockTableRecord(btr2,ids);
//Adds the selected objects to block2,then adds block2 to the block table of AutoCAD database.
}
  • CoordFromPixelToWorld() and CoordFromWorldToPixel()
There's no first class .NET API to convert pixel to world coordinates and back.Special thanks to Albert Szilvasy on Autodesk discussion group providing the way to solve this problem. The following example shows you how to use CoordFromPixelToWorld() and CoordFromWorldToPixel() function to convert pixel to world coordinates and back. Note:Inorder to use the two functions,you must add the System.Drawing.dll assembly to your project.
    void Test()
{
Editor ed=Tools.Editor;
Point3d pt1=ed.GetPoint("\nPlease select a point:").Value;
System.Drawing.Point pix1;//You must add the System.Drawing.dll in the reference of your project.
Tools.CoordFromWorldToPixel(0,ref pt1,out pix1);
ed.WriteMessage("\npixel coordinate is"+pix1.ToString()+",world coordinate is"+pt1.ToString());

System.Drawing.Point pix2=new System.Drawing.Point(100,100);
Point3d pt2;
Tools.CoordFromPixelToWorld(0,pix2,out pt2);
ed.WriteMessage("\npixel coordinate is"+pix2.ToString()+",world coordinate is"+pt2.ToString());
}
  • GetBoundingBox()
In the .NET API,the GeomExtents property of an entity can get the corner points of a box that encloses the 3D extents of the entity.But for DBText and MText,the GeomExtents property always returns the point (0,0,0) for the minpoint of the box.So,DOTNETARX provides the GetBoundingBox() function to let you get the correct corner points of an entity including the DBText and the MText object.The return value of GetBoundingBox() is a Point3d array,[0] is the minimum point of the object's bounding box,[1] is the maximum point of the object's bounding box. The following example shows you how to use GetBoundingBox().
    void Test()
{
Editor ed=Tools.Editor;
ObjectId id=ed.GetEntity("Please select an entity on the screen:\n").ObjectId;
//Gets the ObjectId of a selected entity.
Point3d[] pts=Tools.GetBoundingBox(id);//Gets the the two points of a box enclosing the selected entity.
Lines line=new Lines(pts[0],pts[1]);//Creates a line to see the output.
Tools.AddEntity(line);
}
  • Sendcommand and Regen
Sendcommand() function sends a command string to the current document for processing.
There is no Regen function in .NET API,so I add the Regen() function in DOTNETARX.
The following example sends a command for evaluation to the AutoCAD command line of a particular drawing. Create a Circle in the active drawing and zoom to display the entire circle.
    void Test()
{
Tools.SendCommand("_Circle","2,2,0","4");//You don't need the character "\n" for the Return action.
Tools.SendCommand("_zoom","a");
Tools.Regen(Tools.RegenType.AllViewPorts);//Refresh view
}
DOTNETARX 2.1 及帮助文档

本帖子中包含更多资源

您需要 登录 才可以下载或查看,没有账号?注册

x
发表于 2005-7-5 21:20:00 | 显示全部楼层
楼主,这个附件是跟6用21号那个 “DOTNETARX(就是原来的ZHFARX)实例教学”里的区别是什么呢?怎么好象旧版的那个Dotnetarx.dll的文件还比较大?
 楼主| 发表于 2005-7-6 09:10:00 | 显示全部楼层
这个是最新的,因为上次的是中文的。
您需要登录后才可以回帖 登录 | 注册

本版积分规则

小黑屋|手机版|CAD论坛|CAD教程|CAD下载|联系我们|关于明经|明经通道 ( 粤ICP备05003914号 )  
©2000-2023 明经通道 版权所有 本站代码,在未取得本站及作者授权的情况下,不得用于商业用途

GMT+8, 2024-11-25 06:29 , Processed in 0.164767 second(s), 25 queries , Gzip On.

Powered by Discuz! X3.4

Copyright © 2001-2021, Tencent Cloud.

快速回复 返回顶部 返回列表